#include <stdio.h>
#include <stdlib.h>
#include "mpi.h"

int main (int argc, char** argv)
{
  int number_of_processes;
  int my_rank;
  int mpi_error_code;

  mpi_error_code = MPI_Init(&argc, &argv);

    mpi_error_code = MPI_Comm_rank(MPI_COMM_WORLD, &my_rank);

    mpi_error_code = MPI_Comm_size(MPI_COMM_WORLD, &number_of_processes);

    //This is the server process.
    if(my_rank == 0)
    {
      printf("Hello from the server!\n");

      int i;
      for(i = 1; i < number_of_processes; i++)     
        mpi_error_code = MPI_Send("Hi from server!", 16, MPI_CHAR, i, 0, MPI_COMM_WORLD);

      printf("Message was sent from server!\n");
    }
    else
    {
      printf("Hello from client with rank %d!\n", my_rank);

      char str[20];
      mpi_error_code = MPI_Recv(str, 20, MPI_CHAR, 0, 0, MPI_COMM_WORLD, MPI_STATUS_IGNORE);

      printf("The message received in client %d is: %s\n", my_rank, str);
    }

  mpi_error_code = MPI_Finalize();
  return 0;
}
